Index: /trunk/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 276)
+++ /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 284)
@@ -985,36 +1094,36 @@
 							2 => 'cc_id',
 							3 => 'cc_contacts'
-						)						
-					);					
-					
+						)
+					);
+
 					$groups =& $this->bo->catalog->get_multiple_entries($ids,$fields);
-					
+
 					$i = 0;
 					// contatos do grupo
-					$boGroups = CreateObject('contactcenter.bo_group');					
+					$boGroups = CreateObject('contactcenter.bo_group');
 					$contacts = array();
 					foreach($groups as $group)		{
-										
+
 						$final[3][$i][0] = $group['title'] ? $group['title'] : 'none';
-						$final[3][$i][1] = $group['short_name'] ? $group['short_name'] : 'none';						
+						$final[3][$i][1] = $group['short_name'] ? $group['short_name'] : 'none';
 						$final[3][$i][2] = $group['id_group'] ? $group['id_group'] : 'none';
 						$contacts = $boGroups -> get_contacts_by_group($group['id_group']);
 						$final[3][$i][3] = $contacts;
-						$i++;							
+						$i++;
 					}
-					
+
 					$this->page_info['actual_letter'] = $letter;
-					$this->page_info['actual_page'] = $page;					
-					
-					
+					$this->page_info['actual_page'] = $page;
+
+
 					$lnk_compose = "location.href=('../expressoMail1_2/index.php?to=";
-					
+
 					$final[5] = '<span class="link"  onclick="'.$lnk_compose;
-					$final[10] = 'groups';																												
-					$this->save_session();					
+					$final[10] = 'groups';
+					$this->save_session();
 					echo serialize($final);
-					return;					
-				}
-				
+					return;
+				}
+
 				$fields['photo'] = true;
 				$fields['names_ordered'] = true;
@@ -1023,7 +1132,8 @@
 				$fields['companies'] = 'default';
 				$fields['connections'] = 'default';
+
+				// ?aqui alterar a chamada desse mï¿œtodo para receber o base dn?
 				$contacts =& $this->bo->catalog->get_multiple_entries($ids,$fields);
-				
-				
+
 				if (!is_array($contacts) or !count($contacts))
 				{
@@ -1033,95 +1143,117 @@
 					return;
 				}
-				
+
 				$i = 0;
-				foreach($contacts as $contact)
-				{
-					$final[3][$i][0] = $contact['companies']['company1']['company_name']?$contact['companies']['company1']['company_name']:'none';
-					$final[3][$i][1] = $contact['names_ordered'] ? $contact['names_ordered'] : 'none';
-					$final[3][$i][2] = $contact['companies']['company1']['title']?$contact['companies']['company1']['title']:'none';
-
-					/* Select the correct Email and Telephone to be shown */
-					$preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
-					if (!is_array($preferences))
-					{
-						$preferences['personCardEmail'] = 1;
-						$preferences['personCardPhone'] = 2;
-					}
-					if ($contact['connections'])
-					{
-						$default_email_found = false;
-						$default_phone_found = false;
-						foreach($contact['connections'] as $conn_info)
+				foreach($contacts as $index => $contact)
+				{
+					/*
+					 * TODO: Os timeouts de conexï¿œo foram retirados, ver se serï¿œ necessï¿œrio retornar essa funcionalidade, e,
+					 * neste caso, terminar a implementaï¿œï¿œo das mensagens de retorno.
+					 */
+					if ($index !== 'error'){
+						$final[3][$i][0] = $contact['companies']['company1']['company_name']?$contact['companies']['company1']['company_name']:'none';
+						$final[3][$i][1] = $contact['names_ordered'] ? $contact['names_ordered'] : 'none';
+						$final[3][$i][2] = $contact['companies']['company1']['title']?$contact['companies']['company1']['title']:'none';
+
+						//Para exibir a matricula do empregado
+						$final[3][$i][8] = $contact['companies']['company1']['empNumber']?$contact['companies']['company1']['empNumber']:'none';
+						//Para exibir o setor/lotaï¿œï¿œo do empregado
+						$final[3][$i][9] = $contact['companies']['company1']['department']?$contact['companies']['company1']['department']:'none';
+
+						/* Select the correct Email and Telephone to be shown */
+						$preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
+						if (!is_array($preferences))
 						{
-							if ($conn_info['id_type'] == $preferences['personCardEmail'] and !$default_email_found)
+							$preferences['personCardEmail'] = 1;
+							$preferences['personCardPhone'] = 2;
+						}
+						if ($contact['connections'])
+						{
+							$default_email_found = false;
+							$default_phone_found = false;
+							foreach($contact['connections'] as $conn_info)
 							{
-								if ($conn_info['connection_is_default'])
+								if ($conn_info['id_type'] == $preferences['personCardEmail'] and !$default_email_found)
 								{
-									$default_email_found = true;
+									if ($conn_info['connection_is_default'])
+									{
+										$default_email_found = true;
+									}
+									$final[3][$i][4] = $conn_info['connection_value'] ? $conn_info['connection_value'] : 'none';
 								}
-								$final[3][$i][4] = $conn_info['connection_value'] ? $conn_info['connection_value'] : 'none';
-							}
-							else if ($conn_info['id_type'] == $preferences['personCardPhone'] and !$default_phone_found)
-							{
-								if ($conn_info['connection_is_default'])
+								else if ($conn_info['id_type'] == $preferences['personCardPhone'] and !$default_phone_found)
 								{
-									$default_phone_found = true;
+									if ($conn_info['connection_is_default'])
+									{
+										$default_phone_found = true;
+									}
+									
+									if (!($_SESSION['phpgw_info']['user']['preferences']['contactcenter']['telephone_number'] == $conn_info['connection_value']) && $_SESSION['phpgw_info']['user']['preferences']['contactcenter']['voip_enabled'] && $conn_info['connection_value'] && preg_match('/^\([0-9]{2}\)[0-9]{4}\-[0-9]{4}$/',$conn_info['connection_value'])==1 && !$external) {
+										$conn_info['connection_value'] = "<a title=\"".lang("Call Extension")."\" href=\"#\" onclick=\"connectVoip('".$conn_info['connection_value']."', 'com')\">".$conn_info['connection_value']."</a>";
 								}
-								$final[3][$i][3] = $conn_info['connection_value'] ? $conn_info['connection_value'] : 'none';
+									
+									$final[3][$i][3] = $conn_info['connection_value'] ? $conn_info['connection_value'] : 'none';
+								}
 							}
 						}
+
+						if (!$final[3][$i][3])
+						{
+							$final[3][$i][3] = 'none';
+						}
+
+						if (!$final[3][$i][4])
+						{
+							$final[3][$i][4] = 'none';
+						}
+
+						$final[3][$i][5] = $contact['alias']?$contact['alias']:'none';
+						$final[3][$i][6] = $ids[$i];
+
+					//	If contact is a public list, then load the forwarding addresses.
+						if($contact['account_type'][0] == 'l')
+							$final[3][$i][7] = array();
+
+						$final[4][$i] = $contact['photo'] ? 1  : 0;
+						$i++;
+
 					}
-					
-					if (!$final[3][$i][3])
+					else
 					{
-						$final[3][$i][3] = 'none';
+						// coloca mensagem de erro no vetor que retorna para o browser
 					}
-					
-					if (!$final[3][$i][4])
-					{
-						$final[3][$i][4] = 'none';
-					}
-
-					$final[3][$i][5] = $contact['alias']?$contact['alias']:'none';
-					$final[3][$i][6] = $ids[$i];
-
-				//	If contact is a public list, then load the forwarding addresses.
-					if($contact['account_type'][0] == 'l')
-						$final[3][$i][7] = array();
-
-					$final[4][$i] = $contact['photo'] ? 1  : 0;
-					$i++;
-				}
-				$lnk_compose = "location.href=('../expressoMail1_2/index.php?to=";				
+				}
+				$lnk_compose = "location.href=('../expressoMail1_2/index.php?to=";
 				$final[5] = '<span class="link" onclick="'.$lnk_compose;
-				
-				
+
+
 				$this->page_info['actual_letter'] = $letter;
 				$this->page_info['actual_page'] = $page;
-				
-				$this->save_session();				
+
+				$this->save_session();
+
 				echo serialize($final);
 				return;
 			}
-			
+
 			$this->page_info['actual_letter'] = $letter;
 			$this->page_info['actual_page'] = $page;
-			
+
 			$this->save_session();
-			
+
 			$final[0] = 0;
 			$final[1] = $this -> typeContact;
 			echo serialize($final);
 		}
-		
+
 		/*!
-		
+
 			@function get_group_data
 			@abstract Returns all the information of a given Group
 			@author Nilton Emilio Buhrer Neto
-			
+
 			@param (integer) $id The id to get information
-		
-		*/		
+
+		*/
 		function get_group_data($id)
 		{
@@ -1129,38 +1261,31 @@
 			$fields = $this->bo->catalog->get_fields(true);
 			$data = $this->bo->catalog->get_single_entry($id,$fields);
-			
-			if($id) {			
+
+			if($id) {
 				// get All Contacts by group.
-				$data['contact_in_list'] = $this->bo->catalog->get_contacts_by_group($id);								
-			}
-			
+				$data['contact_in_list'] = $this->bo->catalog->get_contacts_by_group($id);
+			}
+
 			$boGroup = CreateObject('contactcenter.bo_group');
-						
-			$all_contacts = $boGroup->get_all_contacts();
-			
-			$contact_options = "";
-			if(count($all_contacts)) {					
-				foreach($all_contacts as $idx => $contact) {				
-					$contact_options .= "<OPTION value='".$contact['id_connection']."'>".$contact['names_ordered']." (".$contact['connection_value'].")</OPTION>";
-				}
-			}
-			$data['contact_list'] = $contact_options;
-			$data['result'] = 'ok';								
-			echo serialize($data);			
-		}		
-		
+
+			$data['contact_list'] = $boGroup->get_all_contacts();
+
+			$data['result'] = 'ok';
+			echo serialize($data);
+		}
+
 		/*!
-		
+
 			@function get_full_data
 			@abstract Returns all the information of a given Entry
 			@author Raphael Derosso Pereira
-			
+
 			@param (integer) $id The id to get information
-		
+
 		*/
 		function get_full_data($id)
 		{
 			$dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
-			$this->bo->catalog = CreateObject('contactcenter.bo_people_catalog');		
+			$this->bo->catalog = CreateObject('contactcenter.bo_people_catalog');
 			$fields = $this->bo->catalog->get_fields(true);
 			$fields['photo'] = false;
@@ -1195,5 +1320,5 @@
 			}
 			$datecount = 0;
-			
+
 			$data['result'] = 'ok';
 			$data['cc_full_add_contact_id'] = $id;
@@ -1237,5 +1362,5 @@
 
 			/* Relations */
-			
+
 			echo serialize($data);
 		}
@@ -1274,26 +1399,26 @@
 				return;
 			}
-			
+
 			echo 0;
 		}
-		
+
 		/*!
-		
+
 			@function quick_add
 			@abstract Adds a new Contact using the Quick Add interface
 			@author Raphael Derosso Pereira
-			
+
 			@param string $sdata Serialized data
 		*/
 		function quick_add($sdata)
 		{
-			
+
 			$sdata = str_replace('\\"', '"', $sdata);
 			$new_array = unserialize($sdata);
 			$tdata = array();
-			
+
 			foreach($new_array as $tmp)
 				$tdata[] = $tmp;
-			
+
 			if (!$tdata)
 			{
@@ -1302,22 +1427,22 @@
 					'status' => 'abort'
 				));
-				
+
 				return;
 			}
-			
-			// verifica se email já existe!
+
+			// verifica se email jï¿œ existe!
 			$boGroup = CreateObject('contactcenter.bo_group');
 			$contact = $boGroup->verify_contact($tdata[4]);
-												
+
 			if($contact)
-			{							
+			{
 				$str_contact = "\r\n - ".implode("\r\n - ",$contact);
-				
+
 				echo serialize(array(
 					'msg'    => lang('Problems on adding your Contact. The email "%1" already exists in: %2',$tdata[4], $str_contact),
 					'status' => 'alreadyExists'
 				));
-				
-				return;			
+
+				return;
 			}
 
@@ -1335,7 +1460,7 @@
 
 			if ($boPeople ->quick_add($data))
-			{				
+			{
 				$this->page_info['changed'] = true;
-				
+
 				echo serialize(array(
 					'msg'    => lang('Entry added with success!'),
@@ -1351,14 +1476,14 @@
 			}
 
-			$this->save_session();	
-			
+			$this->save_session();
+
 		}
 
 		/*!
-		
+
 			@function add_group
 			@abstract Adds a new Group using the Add Group interface
 			@author Nilton Emilio Buhrer Neto
-			
+
 			@param string $sdata Serialized data
 		*/
@@ -1368,5 +1493,5 @@
 			$tdata = unserialize($sdata);
 			$new_tdata = array();
-			
+
 			if (!$tdata)
 			{
@@ -1375,22 +1500,22 @@
 					'status' => 'abort'
 				));
-				
+
 				return;
 			}
-			
+
 			foreach($tdata as $tmp)
 				$new_tdata[] = $tmp;
-			
-			$data['title'] = $new_tdata[0];			
+
+			$data['title'] = $new_tdata[0];
 			$data['contact_in_list'] = $new_tdata[1];
 			$data['id_group'] = $new_tdata[2];
-						
+
 			$boGroup = CreateObject('contactcenter.bo_group_manager');
 			$id = $boGroup -> add_group($data);
-			
+
 			if ($id)
 			{
 				$this->page_info['changed'] = true;
-				
+
 				echo serialize(array(
 					'msg'    => lang('Entry added with success!'),
@@ -1410,14 +1535,14 @@
 
 		/*!
-		
+
 			@function remove_group
 			@abstract Removes a group if the user has the right to do it
-			@author Nilton Emilio Buhrer Neto			
+			@author Nilton Emilio Buhrer Neto
 			@param (integer) $id The id to be removed
-				
+
 		*/
 		function remove_group($id)
-		{				
-				$soGroup = CreateObject('contactcenter.so_group');				
+		{
+				$soGroup = CreateObject('contactcenter.so_group');
 				$data = array ('id_group' => $id);
 				if($soGroup -> delete($data)) {
@@ -1425,5 +1550,5 @@
 						'msg'    => lang('Removed Entry ID '.$id.'!'),
 						'status' => 'ok'
-					));							
+					));
 				}
 				else {
@@ -1434,10 +1559,10 @@
 				}
 
-			$this->save_session();				
+			$this->save_session();
 		}
 
 
 		function remove_all_entries (){
-		
+
 			$error = false;
 			$this->all_entries = $this->bo->catalog->get_all_entries_ids();
@@ -1447,5 +1572,5 @@
 				if(!$result) {
 					$error = true;
-					break;		
+					break;
 				}
 			}
@@ -1456,5 +1581,5 @@
 					'status' => 'ok'
 				));
-			} 
+			}
 			else {
 				echo serialize(array(
@@ -1468,11 +1593,11 @@
 
 		/*!
-		
+
 			@function remove_entry
 			@abstract Removes an entry if the user has the right to do it
 			@author Raphael Derosso Pereira
-			
+
 			@param (integer) $id The id to be removed
-				
+
 		*/
 		function remove_entry ($id)
@@ -1483,8 +1608,8 @@
 				return;
 			}
-			
+
 			$this->page_info['changed'] = true;
 			$result = $this->bo->catalog->remove_single_entry($id);
-			
+
 			if ($result)
 			{
@@ -1493,5 +1618,5 @@
 					unset($this->page_info['actual_entries'][$pos]);
 				}
-				
+
 				$temp = false;
 				reset($this->page_info['actual_entries']);
@@ -1500,5 +1625,5 @@
 					$temp[] = $t;
 				}
-				
+
 				$this->page_info['actual_entries'] = $temp;
 
@@ -1515,11 +1640,11 @@
 				));
 			}
-			
+
 			$this->save_session();
 		}
 
-		
+
 		/*!
-		
+
 			@function post_full_add
 			@abstract Saves all the information altered/entered in the Full Add
@@ -1530,9 +1655,8 @@
 		function post_full_add()
 		{
-			$data =  $_POST['data'];
-			// Exceptions!!! utf8 special chars. 
-			$data = preg_replace("/\%u2(\d+)(\d+)(\d+)/","-",$data);
-			$data = unserialize(str_replace('\\"', '"', $data));
+			$data = unserialize(str_replace('\\"', '"', $_POST['data']));
 			$this -> bo -> catalog = CreateObject('contactcenter.bo_people_catalog');
+
+//			echo str_replace('\\"', '"', $_POST['data']);
 
 			if (!is_array($data))
@@ -1558,5 +1682,5 @@
 					'status' => 'fatal'
 				));
-				
+
 				return;
 			}
@@ -1572,7 +1696,7 @@
 				$id_photo = '_new_';
 			}
-			
-			/* 
-			 * Process Photo, if available 
+
+			/*
+			 * Process Photo, if available
 			 */
 			$sleep_count = 0;
@@ -1591,5 +1715,5 @@
 			}
 			$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('wait', 'n'));
-			
+
 			if (isset($this->page_info['photos'][$id_photo]))
 			{
@@ -1608,11 +1732,11 @@
 				$this->save_session();
 			}
-			
+
 			/*
 			 * Arrange Date so it gets inserted correctly
 			 */
-			 
+
 			$dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
-		
+
 			$j = 0;
 			for ($i = 0; $i < 5; $i+=2)
@@ -1647,5 +1771,5 @@
 					continue;
 				}
-				
+
 				switch($field)
 				{
@@ -1659,5 +1783,5 @@
 						/* Do Nothing. This is just to make sure no invalid field is passed */
 						break;
-					
+
 					case 'id_status':
 					case 'id_prefix':
@@ -1668,9 +1792,9 @@
 						}
 						break;
-					
+
 					case 'birthdate_0':
 					case 'birthdate_1':
 					case 'birthdate_2':
-					
+
 						switch($date[$datecount]['digit'])
 						{
@@ -1694,5 +1818,5 @@
 							break;
 						}
-						
+
 						if (!checkdate($date['value'][0], $date['value'][1], $date['value'][2]))
 						{
@@ -1703,5 +1827,5 @@
 							return;
 						}
-						
+
 						$data['birthdate'] = $date['value'][2].'-'.$date['value'][0].'-'.$date['value'][1];
 						break;
@@ -1726,5 +1850,5 @@
 							{
 								$index = 'address'.$type;
-								
+
 								$id_state = $this->bo->catalog->add_state($state_info);
 								$data['addresses'][$index]['id_state'] = $id_state;
@@ -1744,5 +1868,5 @@
 							{
 								$index = 'address'.$type;
-								
+
 								$id_city = $this->bo->catalog->add_city($city_info);
 								$data['addresses'][$index]['id_city'] = $id_city;
@@ -1785,5 +1909,5 @@
 				);
 			}
-			
+
 			eval($code);
 
@@ -1801,5 +1925,5 @@
 
 		/*!
-		
+
 			@function post_photo
 			@abstract Wrapper to post a photo without reload a page.
@@ -1811,10 +1935,10 @@
 			//print_r($_FILES);
 			$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('wait', 'y'));
-			
+
 			if (!is_array($_FILES) and is_array(!$_FILES['cc_pd_photo']))
 			{
 				$this->page_info['photos'][$id]['status'] = 'no_upload';
 				$this->page_info['photos'][$id]['msg'] = lang('No Photos uploaded to Server.');
-				
+
 				$this->save_session();
 				$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('ok', 'y'));
@@ -1826,5 +1950,5 @@
 				$this->page_info['photos'][$id]['status'] = 'no_GD_lib';
 				$this->page_info['photos'][$id]['msg'] = lang('Cannot manipulate Image. No Image added. Please, if you want to use images, ask the Administrator to install GD library.');
-				
+
 				$this->save_session();
 				$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('ok', 'y'));
@@ -1852,5 +1976,5 @@
 				return;
 			}
-			
+
 			switch($_FILES['cc_pd_photo']['type'])
 			{
@@ -1882,5 +2006,5 @@
 
 				default:
-					
+
 					$this->page_info['photos'][$id]['status'] = 'invalid_image';
 					$this->page_info['photos'][$id]['msg'] = lang('The file must be an JPEG, PNG or GIF Image.');
@@ -1895,23 +2019,23 @@
 					$this->page_info['photos'][$id]['status'] = 'invalid_file';
 					$this->page_info['photos'][$id]['msg'] = lang('Couldn\'t open Image. It may be corrupted or internal library doesn\'t support this format.');
-					
+
 					$this->save_session();
 					$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('ok', 'y'));
 					return;
 			}
-			
+
 			$img_size = getimagesize($_FILES['cc_pd_photo']['tmp_name']);
 			$dst_img = imagecreatetruecolor(60, 80);
-			
+
 			if (!imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, 60, 80, $img_size[0], $img_size[1]))
 			{
 				$this->page_info['photos'][$id]['status'] = 'invalid_file';
 				$this->page_info['photos'][$id]['msg'] = lang('Couldn\'t open Image. It may be corrupted or internal library doesn\'t support this format.');
-				
+
 				$this->save_session();
 				$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('ok', 'y'));
 				return;
 			}
-			
+
 			ob_start();
 			imagepng($dst_img);
@@ -1923,5 +2047,5 @@
 
 			$this->save_session();
-		
+
 			$GLOBALS['phpgw']->session->appsession('ui_data.photo','contactcenter', array('ok', 'y'));
 
@@ -1944,5 +2068,5 @@
 			$fields = $this->bo->catalog->get_fields(false);
 			$fields['photo'] = true;
-			
+
 			$contact = $this->bo->catalog->get_single_entry($id, $fields);
 
@@ -1953,5 +2077,5 @@
 				return;
 			}
-			
+
 			header('Content-type: image/jpeg');
 			$photo = imagecreatefromstring ($contact['photo']);
@@ -1965,7 +2089,7 @@
 			return;
 		}
-		
+
 		/*!
-		
+
 			@function get_states
 			@abstract Echos a serialized array containing all the states for the given country
@@ -1989,10 +2113,10 @@
 				return;
 			}
-			
+
 			$result = array(
 				'msg'    => lang('States Successfully retrieved!'),
 				'status' => 'ok'
 			);
-			
+
 			foreach ($states as $state_info)
 			{
@@ -2033,15 +2157,15 @@
 				return;
 			}
-			
+
 			$result = array(
 				'msg'    => lang('Cities Successfully retrieved!'),
 				'status' => 'ok'
 			);
-			
+
 			foreach ($cities as $city_info)
 			{
 				$result['data'][$city_info['id_city']] = $city_info['name'];
 			}
-			
+
 			echo serialize($result);
 		}
@@ -2049,9 +2173,10 @@
 
 		/*!
-		
+
 			@function search
 			@abstract Echos a serialized array containing the IDs
 				of the entries that matches the search argument
 			@author Raphael Derosso Pereira
+			@author Mï¿œrio Cï¿œsar Kolling (external catalogs)
 
 			@param string $str_data A serialized array with two informations:
@@ -2065,13 +2190,26 @@
 		{
 			$data = unserialize($str_data);
+			// It's an external catalog?
+			$external = $this->bo->is_external($this->page_info['actual_catalog']);
 
 			if (!is_array($data) || !$data['search_for'] || !is_array($data['fields']))
 			{
-				echo serialize(array(
-					'msg'    => lang('Invalid parameters'),
-					'status' => 'abort'
-				));
-
-				return;
+				//echo serialize(array(
+				//	'msg'    => lang('Invalid parameters'),
+				//	'status' => 'abort'
+				//));
+
+				return array('error' => lang('Invalid parameters'));
+			}
+
+			/*
+			 * TODO: look into the database to discover the database's encoding and convert the search_for field accordingly
+			 */
+			// Support search parameters with accentuation
+			if ($this->page_info['actual_catalog']['class'] != 'bo_people_catalog' &&
+				$this->page_info['actual_catalog']['class'] != 'bo_group_manager')
+			{
+
+				$data['search_for'] = utf8_encode($data['search_for']);
 			}
 
@@ -2094,12 +2232,44 @@
 				if (!is_array($names))
 				{
-					echo serialize(array(
-						'msg'    => lang('Invalid Search Parameter'),
-						'status' => 'abort'
-					));
-					
-					return;
-				}
-				
+					//echo serialize(array(
+					//	'msg'    => lang('Invalid Search Parameter'),
+					//	'status' => 'abort'
+					//));
+
+					return array('error' => lang('Invalid Search Parameter'));
+				}
+
+				if (!$external && $this->page_info['actual_catalog']['class'] != 'bo_people_catalog' &&
+					$this->page_info['actual_catalog']['class'] != 'bo_group_manager')
+				{
+					/*
+					 * Restrict the returned contacts search to objectClass = phpgwAccount,
+					 * must have attibute phpgwAccountStatus, phpgwAccountVisible != -1 and
+					 * objectClass = inetOrgPerson
+					 */
+					$rules = array(
+						0 => array(
+							'field' => 'contact.object_class',
+							'type'  => '=',
+							'value' => 'phpgwAccount'
+						),
+						1 => array(
+							'field' => 'contact.account_status',
+							'type'  => 'iLIKE',
+							'value' => '%'
+						),
+						2 => array(
+							'field' => 'contact.account_visible',
+							'type'  => '!=',
+							'value' => '-1'
+						),
+						3 => array(
+							'field' => 'contact.object_class',
+							'type'  => '=',
+							'value' => 'inetOrgPerson'
+						)
+					);
+				}
+
 				foreach ($names as $name)
 				{
@@ -2114,28 +2284,35 @@
 				}
 			}
-			
-			/*
-			$catalog = $this->bo->get_branch_by_level($this->bo->catalog_level[0]);
-			
-			if ($catalog['class'] === 'bo_people_catalog')
-			{
-				array_push($rules, array(
-					'field' => 'contact.id_owner',
-					'type'  => '=',
-					'value' => $GLOBALS['phpgw_info']['user']['account_id']
-				));
-			}
-			*/
-			
-			$ids = $this->bo->find(array($data['fields']['id'], $data['fields']['search']), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC'));
+
+			if ($external || $this->page_info['actual_catalog']['class'] == 'bo_people_catalog' ||
+				$this->page_info['actual_catalog']['class'] == 'bo_group_manager')
+			{
+				// Get only this attributes: dn, cn for external catalogs,
+				// used to restrict the attributes used in filters
+				$ids = $this->bo->find(array($data['fields']['id'], $data['fields']['search']), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC'));
+			}
+			else
+			{
+				// Get only this attributes: dn, cn, phpgwAccountType, objectClass, phpgwAccountStatus, phpghAccountVisible
+				// for non-external catalogs, used to restrict the attributes used in filters
+				$ids = $this->bo->find(array(
+					$data['fields']['id'],
+					$data['fields']['search'],
+					'contact.object_class',
+					'contact.account_status',
+					'contact.account_visible'
+					), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC'));
+			}
 
 			if (!is_array($ids) || !count($ids))
 			{
-				echo serialize(array(
-					'msg'    => lang('No Entries Found!'),
-					'status' => 'empty'
-				));
-
-				return;
+				//echo serialize(array(
+				//	'msg'    => lang('No Entries Found!'),
+				//	'status' => 'empty'
+				//));
+
+				$this->last_search_ids = null;
+				$this->save_session();
+				return null;
 			}
 
@@ -2145,12 +2322,18 @@
 			foreach ($ids as $e_info)
 			{
+				//$ids_f[] = "base64::" . base64_encode($e_info[$id_field]);
 				$ids_f[] = $e_info[$id_field];
 			}
-			
-			echo serialize(array(
-				'data'   => $ids_f,
-				'msg'    => lang('Found %1 Entries', count($ids)),
-				'status' => 'ok'
-			));
+
+			//error_log("ids_f serializados: " . serialize($ids_f) . "\n", 3, '/var/www/teste.log');
+
+			//return serialize($ids_f);
+			return $ids_f;
+
+			//echo serialize(array(
+			//	'data'   => $ids_f,
+			//	'msg'    => lang('Found %1 Entries', count($ids)),
+			//	'status' => 'ok'
+			//));
 		}
 
@@ -2162,5 +2345,5 @@
 			@author Raphael Derosso Pereira
 
-			@param array str_data A serialized array containing the ID's of the entries 
+			@param array str_data A serialized array containing the ID's of the entries
 				to be taken, the fields to be taken and the rules to be used on the
 				retrieval:
@@ -2175,5 +2358,5 @@
 		{
 			$data = unserialize($str_data);
-			
+
 			if (!is_array($data) or !count($data) or !count($data['fields']) or !count($data['ids']))
 			{
@@ -2185,5 +2368,5 @@
 
 			$entries = $this->bo->catalog->get_multiple_entries($data['ids'], $data['fields']);
-			
+
 			if (!is_array($entries) or !count($entries))
 			{
@@ -2204,9 +2387,9 @@
 
 			@function get_all_entries
-			@abstract Returns the specified fields for all catalog's entries 
+			@abstract Returns the specified fields for all catalog's entries
 				in the default CC UI format
 			@author Raphael Derosso Pereira
 
-			@params array str_data A serialized array containing the fields to 
+			@params array str_data A serialized array containing the fields to
 				be grabbed, the maximum number of entries to be returned and a
 				boolean specifying if the calls refers to a new grab or to an
@@ -2217,8 +2400,8 @@
 		{
 			$data = unserialize($str_data);
-			
-			if (!is_array($data) or 
-			    !count($data) or 
-				!count($data['fields']) or 
+
+			if (!is_array($data) or
+			    !count($data) or
+				!count($data['fields']) or
 				!$data['maxlength'] or
 				(!$data['new'] and !$data['offset']))
@@ -2246,5 +2429,5 @@
 				$data['offset'] = 0;
 			}
-			
+
 			if ($data['maxlength'] != -1)
 			{
@@ -2257,5 +2440,5 @@
 
 			$prefs = ExecMethod('contactcenter.ui_preferences.get_preferences');
-			
+
 			$jsCode = array();
 			$count = 0;
@@ -2267,21 +2450,21 @@
 				}
 
-				if($this-> typeContact == 'groups') {				
-					
+				if($this-> typeContact == 'groups') {
+
 					foreach ($each as $field => $value)	{
-										
+
 						if ($field === 'title')	{
 							$optionName = '\\"'.$value.'\\"';
-							 
+
 						}
 						else if ($field === 'short_name')	{
-							
+
 							$jsCode[] = '_this.entries.options[_this.entries.options.length] = new Option("'.$optionName.' ('.$value.')", "'.$count.'");';
-							$count++;																					
-						}					
+							$count++;
+						}
 					}
 				}
-				
-				else  {	
+
+				else  {
 					foreach ($each as $field => $value)	{
 						if ($field === 'names_ordered')	{
@@ -2291,5 +2474,5 @@
 						}
 						else if ($field === 'connections')	{
-							
+
 							foreach ($value as $connection)		{
 								if ($connection['id_type'] == $prefs['personCardEmail'])	{
@@ -2304,7 +2487,7 @@
 
 			$jsCodeFinal = implode("\n", $jsCode);
-			
+
 			$nEntries = count($result);
-			
+
 			if (!$nEntries)
 			{
@@ -2324,5 +2507,5 @@
 			);
 		}
-		
+
 		/*********************************************************************\
 		 *                      Auxiliar Methods                             *
@@ -2330,9 +2513,9 @@
 
 		/*!
-		
+
 			@function save_session
 			@abstract Saves the data on the session
 			@author Raphael Derosso Pereira
-		
+
 		*/
 		function save_session()
@@ -2340,13 +2523,14 @@
 			$GLOBALS['phpgw']->session->appsession('ui_data.page_info','contactcenter',$this->page_info);
 			$GLOBALS['phpgw']->session->appsession('ui_data.all_entries','contactcenter',$this->all_entries);
+			$GLOBALS['phpgw']->session->appsession('ui_data.last_search_ids','contactcenter',$this->last_search_ids);
 		}
 
 		/*!
-		
+
 			@function convert_tree
 			@abstract Converts the tree array in the BO format to a JS tree array compatible
 				with the one available in eGW
 			@author Raphael Derosso Pereira
-		
+
 			@param (array)  $tree    The tree in the BO format
 			@param (string) $name    The tree name
@@ -2382,5 +2566,5 @@
 					'caption' => $value['name']
 				);
-				
+
 				switch($value['type'])
 				{
@@ -2405,12 +2589,12 @@
 				$this->bo->catalog->src_info = $ldap->srcs[1];
 			}
-			
-			$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], true);				
+
+			$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], true);
 			$dn=$this->bo->catalog->src_info['dn'];
 			$justThese = array("givenname","givenname","sn","telephonenumber","mail");
-			$sr = ldap_read($ds,$id, "objectClass=*",$justThese);							
-			$info = ldap_get_entries($ds, $sr);							
+			$sr = ldap_read($ds,$id, "objectClass=*",$justThese);
+			$info = ldap_get_entries($ds, $sr);
 			for($z = 0; $z < 5; $z++) {
-				$participant = $info[0][$justThese[$z]];													
+				$participant = $info[0][$justThese[$z]];
 				array_push($array_participants, $participant);
 			}
